<frontpage-quotes>
    <!--  <div class="box_content">
        <div id="quotstable_block">
            <table class="quotes-table">
                <thead>
                    <tr>
                        <th>Instrument</th>
                        <th>Bid</th>
                        <th>Ask</th>
                        <th>Spread</th>
                    </tr>
                </thead>
                <tbody>
                    <tr each={quotes()} data-quote="{name}">
                        <td><span>{name}</span></td>

                        <td>
                            <raw content="{bid}"></raw>
                            <i if={db==1} class="fas fa-sort-up"></i>
                            <i if={db==-1} class="fas fa-sort-down"></i>
                        </td>

                        <td>
                            <raw content="{ask}"></raw>
                            <i if={db==1} class="fas fa-sort-up"></i>
                            <i if={db==-1} class="fas fa-sort-down"></i>
                        </td>
                        <td>{spread}</td>
                    </tr>
                </tbody>
            </table>
            

        </div>
    </div>  -->


<div class="dropdown">
    <select id="quotes-select" onchange="{handleSelect}">
        <option each={quote, i in lp_quotes().slice(0,1)} data-quote={i} selected={current==i} value={quote.name}>{quote.name}</option>
    </select>
</div>
<div each={quote, i in lp_quotes().slice(0,1)} data-quote={i} class="quotes-items d-flex justify-content-between">
    <div class="item best-bid up" >
        <p class="d-flex px11">
            <span>ЛУЧШИЙ БИД</span>
            <span>
                <i if={quote.db==1} class="up"></i>
                <i if={quote.db==-1} class="down"></i>
            </span>
        </p>
        <p class="value px18"><raw content="{quote.bid}"></raw></p>
    </div>
    <div class="item spread">
        <p class="px11">СПРЕД</p>
        <p class="value gotp-bd px38">{quote.spread}</p>
    </div>
    <div class="item best-ask down">
        <p class="d-flex px11">
            <span>ЛУЧШИЙ ACK</span>
            <span>
                <i if={quote.db==1} class="up"></i>
                <i if={quote.db==-1} class="down"></i>
            </span>
        </p>
        <p class="value px182"><raw content="{quote.ask}"></raw></p>
    </div>
</div>

    <!--  this.value = ''
    this.selected = ''
    this.data = ''
      
    this.handleSelect = function(e){
        this.value = e.target.value
        console.log(e.target.value);
        
        this.options = e.target.options
        console.log(e.target.options);

        this.selected = e.target.selectedIndex
        console.log(e.target.selectedIndex);

        this.data = e.target.i
        console.log(e.target.i);
    }  -->
    

    <script>
    
        lp_quotes() {return Array.from(this.quotes_map.values()).slice(0, 5);}

        updateQuotesFromWs(event) {
            var quotes = JSON.parse(event.data);
            

            this.quotes_map.forEach(function(value, key, map) {
                value.da = 0;
                value.db = 0;
            });

            for (var i = quotes.length - 1; i >= 0; i--) {
                // Remove extra 'b' from names.
                var last_letter = quotes[i].name.substr(-1);
                if (last_letter === 'b') {
                    quotes[i].name = quotes[i].name.substr(0, quotes[i].name.length - 1);
                };

                // Force proper ask and bid decimal places.
                var digits = quotes[i].digits;
                quotes[i].ask = quotes[i].ask.toFixed(digits);
                quotes[i].bid = quotes[i].bid.toFixed(digits);

                if (digits === 3 || digits === 5) {
                    quotes[i].ask = customPipette(quotes[i].ask);
                    quotes[i].bid = customPipette(quotes[i].bid);
                }

                this.quotes_map.set(quotes[i].name, quotes[i]);
            }

            this.update();
        }

        quotes() {
            return Array
                .from(this.quotes_map.values()).slice(0, 15);
        }

        this.quotes_map = new Map();
        this.socket = new ReconnectingWebSocket("wss://ws.amarkets.com/wss/quotes_tiny");
        this.socket.onmessage = this.updateQuotesFromWs;

        // Кастомная пипетка.
        function customPipette(quote) {
            var customHtml = '';
            var digitBeforePoint = quote.split('.')[0];
            var digitAfterPoint = quote.split('.')[1];
            var digitAfterPointArray = digitAfterPoint.split('');

            var quoteWithoutPipette = digitAfterPoint.substr(0, digitAfterPointArray.length - 1);
            var quotePipette = digitAfterPointArray[digitAfterPointArray.length - 1];
            customHtml = digitBeforePoint + '.' + quoteWithoutPipette + '<span class="quote-pipette">' + quotePipette + '</span>';
            return customHtml;
        }

        riot.tag('raw', '<span></span>', function (opts) {
            this.updateContent = function () {
                this.root.innerHTML = opts.content;
            };

            this.on('update', function() {
                this.updateContent();
            });

            this.updateContent();
        });
    </script>



    <style>
        .c-green {
            color: #94c94b;
        }
        .c-red {
            color: #c82327;
        }
    </style>
</frontpage-quotes>
